//
//  ViewController.swift
//  L6Starter
//
//  Created by Mindy Lou on 11/3/18.
//  Copyright © 2018 Cornell AppDev. All rights reserved.
//

import UIKit
import SnapKit

class ViewController: UIViewController {

    // MARK: UI components
    var tableView: UITableView!

    // MARK: Data variables
    var courses = [Course]()

    // MARK: Constants
    let reuseIdentifier = "ClassTableViewCellReuse"

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        title = "Course Shopping Cart"
        view.backgroundColor = .white

        tableView = UITableView()
        tableView.delegate = self
        tableView.dataSource = self

        view.addSubview(tableView)

        setupConstraints()
        getCourses()
    }

    func setupConstraints() {
        tableView.snp.makeConstraints { make in
//            make.top.bottom.leading.trailing.equalToSuperview()
            make.edges.equalToSuperview()
        }
    }

    // TODO: How do we make a call to the internet to load our shopping cart?
    func getCourses() {
        NetworkManager.getClasses()
    }

}

// MARK: - Table view data source
extension ViewController: UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return courses.count
    }

    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: reuseIdentifier, for: indexPath) as! CoursesTableViewCell
        cell.configure(for: courses[indexPath.row])
        return cell
    }

    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 50
    }
}

// MARK: - Table view delegate
extension ViewController: UITableViewDelegate {
    // Why is there nothing here? 
}

